// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#include <iostream>
#include <fstream>

#include "Algorithm.h"
#include "MyMacros.h"

using namespace std;



Algorithm::Algorithm()
  {
  nbEqn=0;
  }



Algorithm::~Algorithm()
  {
  }



/*!\brief Reads information from the input FLW file concerning Algorithm.
 *
 *  Reads information and gets the labels of all the Equations involved in the Algorithm from the input FLW file.
 *
 * \param inputFile A reference to the input FLW file.
 */
void Algorithm::read(ifstream& inputFile)
  {
  string keyword;

  inputFile >> keyword;
  if(keyword != "\{")
    {
    ERROR_IN_FILE;
    cerr << "Expecting an opening \"\{\" before Algorithm block!" << endl;
    assert(0);
    exit(-1);
    }
  inputFile >> keyword;

  MyVector<string> knownKeywords;
  knownKeywords.resize(2);
  knownKeywords[0]="//";

  while (keyword!="}")
    {
    switch(knownKeywords.search(keyword))
      {
      case  0 : getline(inputFile,keyword); break;
      case -1 :
              {
	      nbEqn++;
	      labels.resize(nbEqn);
	      labels[nbEqn-1] = keyword;
              break;
              }
      default : break ;
      }
    inputFile >> keyword;
    }
  cout << "System composed of "<<nbEqn<<" Equations:";
  for(int i=0;i<nbEqn;i++)
    {
    cout<<" "<<labels[i];
    }
  cout <<endl;
  pEqn.resize(nbEqn);
  }



void Algorithm::associateEquation(int i, Equation* eqn)
  {
  pEqn[i] = eqn;
  }

