// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef BCHEATFLUX_H
#define BCHEATFLUX_H

using namespace std;

#include <stdlib.h>

#include "BoundaryCondition.h"
#include "MyVector.h"

using namespace std;

class BCHeatFlux : public BoundaryCondition  {
public:
  BCHeatFlux(){};
  virtual ~BCHeatFlux(){};

  virtual void read(ifstream& data_file);
  void updateBCValues();
  double getValue(const int faceNb, const int comp, const MyVector<double>& gradElement);

  double getNormalGrad(const int faceNb, const int comp, const MyVector<double>& gradElement);


private:
  Parser bcFunction; //!< Mathematical Expression of the heat flux to impose at the wall.

};

#endif
