// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef BCTEMPERATUREIMPOSED_H
#define BCTEMPERATUREIMPOSED_H

#include <stdlib.h>

#include "BoundaryCondition.h"
#include "MyVector.h"

using namespace std;

class Parser;

class BCTemperatureImposed : public BoundaryCondition
{
public:
  BCTemperatureImposed(){};
  virtual ~BCTemperatureImposed(){};

  virtual void read(ifstream& inputFile);
  void updateBCValues();
  double getNormalGrad(const int faceNumber, const int comp, const MyVector<double>& gradElement);

  double getValue(const int faceNumber, const int comp, const MyVector<double>& gradElement);
    

private:
  Parser bcFunction; //!< Mathematical Expression of the temperature to impose at the wall.
  double val;

};

#endif
