// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

using namespace std;

#include <stdio.h>
#include <iostream>
#include <fstream>

#include "BoundaryCondition.h"
#include "Mesh.h"
#include "MyMacros.h"

BoundaryCondition::BoundaryCondition()
  {
  };

BoundaryCondition::~BoundaryCondition()
  {
  };


void BoundaryCondition::associateFrontier(const string _name)
  {
  const MyVector<Frontier>& front=pMesh->getRefFrontiers();

  int nbFrontiers = front.size();
  string frontierName;
  int flag=1;
  
  for(int i=0;i<nbFrontiers;i++)
    {
    frontierName = front[i].getName();
    if(frontierName==_name)
      {
      pFrontier = &front[i];
      frontierName = pFrontier->getName();
      flag=0;
      break;
      }
    }
  if(flag)
    {
    ERROR_IN_FILE;
    cerr << "Frontier with name "<< _name<<" not found in Geometry!"<<endl;
    exit(-1);
    }
  }

