// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef EQNALLENCAHN_H
#define EQNALLENCAHN_H

#include "Equation.h"
#include "Variable.h"

class EqnAllenCahn : public Equation  {
public: 
  EqnAllenCahn();
  virtual ~EqnAllenCahn(){};

  virtual void readVirtual(ifstream& inputFile,string& keyword);
  inline Variable& getGamma() {return gamma;};
  inline Variable& getLambda() {return lambda;};
  inline Variable& getBeta() {return beta;};
  inline Variable& getK() {return k;};
  virtual void addsItsVariables4PostProcessing(map<string,const Variable*> & variablesMap);
  
private:
  Variable lambda;
  Variable k;
  Variable gamma;
  Variable beta;
  
  void addBC(ifstream& inputFile);
  void addOperator(ifstream& inputFile);
  };

#endif
