// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef FRONTIER_H
#define FRONTIER_H

#include <stdlib.h>
#include <string>

#include <MyVector.h>

using namespace std;

class Frontier
{
public:
  Frontier();
  ~Frontier();
  
  inline int getFace(const int n) const {assert((n<nbFaces) && (n>-1)); return faces[n];}
  inline string getName() const  {return name;};
  inline int getNbFaces() const {return nbFaces;};
  inline int getNbFirstFace() const {return faces[0];};
/*  VortexFlow 10/08/2004 Has to be removed: useless ? */
inline int getPhysicalNumber() const {return physicalNumber;}
/* */
  void setNbFaces(const int n){assert(n>0); nbFaces=n; faces.resize(n);}
  void setFace(const int i,const int num){assert((i>-1) && (i<nbFaces)); faces[i]=num;}
  void setName(const string _name) {name = _name;};
/*  VortexFlow 10/08/2004 Has to be removed: useless ? */
  void setPhysicalNumber(const int num){physicalNumber=num;}
/* */
  
private:
  string name;            //!< The name of the frontier given by the user
  MyVector<int> faces;    //!< Vector containing the numbers of the faces composing the Frontier
  int nbFaces;            //!< Number of faces composing the Frontier
/* "physical_number" Should not exist : specific to gmsh only
   Now they need to exist because mesh_gmsh uses it but it should be corrected !
VortexFlow 10/08/2004 */
  int physicalNumber;     //!< Physical number provided by gmsh for the definition of the Frontier and domain.
/* */
  
};

#endif
