// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef MEDIUM_H
#define MEDIUM_H

#include <map>

#include "MyVector.h"
#include "MyMatrix.h"
#include "Variable.h"
#include "Parser.h"

#include <iostream>

using namespace std;


class MediumProperty
{
  public:
  MediumProperty()
  {
  isDefined=0;
  property = new Variable;
  }
  ~MediumProperty(){}

  int isDefined;  // 0 not defined; 1 expression/value defined.
  Parser* expr;
  Variable* property;
};



class Medium
{
public:
  Medium();
  ~Medium();

  void add(ifstream& InputFile);
  void updateProperties();
  inline const string& getLabel()const {return label;};
  inline const Variable& getRho()const {return *(mediumProperties[0].property);};
  inline const Variable& getMu()const {return *(mediumProperties[1].property);};
  inline const Variable& getLambda()const {return *(mediumProperties[2].property);};
  inline const Variable& getCp()const {return *(mediumProperties[3].property);};
  void setNbValuesOfProperties(int nbValues);
  void addsItsVariables4PostProcessing(map<string,const Variable*> & variablesMap);

  
private:
  MyVector<MediumProperty> mediumProperties;
  string label;
};

#endif
