// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef OPDIFFUSION_H
#define OPDIFFUSION_H

#include <stdio.h>
#include <stdlib.h>

#include "Variable.h"
#include "Operator.h"

using namespace std;

class OpInterpolation;

class OpDiffusion : public Operator
{
 public: 
  OpDiffusion();
  ~OpDiffusion(){};

  void evaluate(const Variable& parameter, const Variable& field, Variable& result);
  virtual double getStabilityTimeStep(const Variable& diffusivity);

 private:
  MyVector<double> position;
  MyVector<double> positionElement;
  MyVector<double> unitSurfVect;

  MyVector<double> XYZ_P; //!< Corresponds to the XYZ position of the element denoted by nbr1.
  MyVector<double> XYZ_E; //!< Corresponds to the XYZ position of the present element denoted by nbr0.
  MyVector<double> XYZ_f; //!< XYZ position of the face center.
  Variable gradient;      //!< The gradient of the field (used for the corrective term) at the previous time step.
  bool itIsThefirstTimeStep; //!< Flag to know if it's the first time step in order to calculate or not the gradient field.
  OpInterpolation* opInterp;
};

#endif
