// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef OPINTERPOLATION_H
#define OPINTERPOLATION_H

#include <stdio.h>
#include <stdlib.h>

#include "Operator.h"
#include "MyMatrix.h"

using namespace std;

class Variable;

class OpInterpolation : public Operator
{
 public: 
  OpInterpolation();
  ~OpInterpolation(){};

  void initialize();

  void evaluateWithMean(const Variable& field, Variable& result);
  void evaluateLinearly(const Variable& field, Variable& result);
  void evaluateWithGradient(const Variable& field, const Variable& gradient, Variable& result);

 private:
 
  MyVector<double> gamma;
  MyMatrix<double> dIf;

};

#endif
