// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef OPERATOR_H
#define OPERATOR_H

#include <stdio.h>
#include <stdlib.h>

class Equation;
class Variable;
class Mesh;

using namespace std;

class Operator
{
public: 
  Operator(){};
  ~Operator(){};

  void associateMesh(Mesh * _pMesh){ pMesh = _pMesh;};
  void associateMesh(const Mesh * _pMesh){ pMesh = _pMesh;};
  void associateEqn(Equation * _pEquation){ pEquation = _pEquation;};
  void associateEqn(const Equation * _pEquation){ pEquation = _pEquation;};
  virtual void initialize(){};
  virtual void evaluate(const Variable& parameter, const Variable& field, Variable& result){};
  virtual double getStabilityTimeStep(const Variable& parameter){return 10e30;};

protected:
  const Equation* pEquation;
  const Mesh* pMesh;
};

#endif
