// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef POSTGLOBAL_H
#define POSTGLOBAL_H

#include <stdio.h>
#include <stdlib.h>

#include "PostProcField.h"
//#include "Variable.h"

using namespace std;

class Variable;

class PostGlobal {
public: 
  PostGlobal();
  ~PostGlobal();
  
  
  void read(ifstream& inputFile);  //!< Reads in the input file, the block related to a global Post-Processing definition.
  
  void setMesh(Mesh * _pMesh){ pMesh = _pMesh;};
  void setMesh(const Mesh * _pMesh){ pMesh = _pMesh;};
  inline void setRefVariable(const Variable * _var){ Var= _var;};
  inline string & getFieldName() { return fieldName;};
  void createOutputFile();
  void execute(double time, bool forceExecution = 0);
  void finish();

private:
  const Mesh* pMesh;
  string fieldName;
  double tInit,dt,tEnd;
  double lastPostProcessingTime;
  const Variable * Var;
  PostProcField * pPostProcField;
  ofstream* mainFile;
};

#endif
