// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef POSTPROBE_H
#define POSTPROBE_H

#include <stdio.h>
#include <stdlib.h>
#include <iostream>

#include "MyVector.h"

using namespace std;

class Variable;

class PostProbe {
public: 
  PostProbe();
  ~PostProbe();
  
  
  void read(ifstream& inputFile);  //!< Reads in the input file, the block related to probe definition
  
  void createOutputFile(int numberOfTheProbe);
  inline void setRefVariable(const Variable * _var){ var= _var;};
  inline void setProbePosition(MyVector<double> position) { probePosition = position;};
  inline void setElementNumberOfProbe(int elemNum) { elementNumber = elemNum;};

  inline string & getFieldName() { return fieldName;};
  inline const MyVector<double>  getProbePosition() { return probePosition;};
  void execute(double time, bool forceExecution = 0);
  void finish() {};

private:
  string fieldName;
  double tInit,dt,tEnd;
  double lastPostProcessingTime;
  MyVector<double> probePosition;
  const Variable * var;
  int elementNumber;
  ofstream* file;
};

#endif
