// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef POSTPROCESSING_H
#define POSTPROCESSING_H

#include <stdio.h>
#include <iostream>

#include "PostProbe.h"
#include "PostGlobal.h"
#include "MyVector.h"

class Mesh;

using namespace std;

class PostProcessing {
public: 
  PostProcessing();
  ~PostProcessing();
  
  void read(ifstream& inputFile); //!< reads post-processing block in input file.
  
  inline const int getnbPostGlobal(){return nbPostGlobal;};
  inline MyVector<PostGlobal> & getPostGlobalList() {return postGlobalList;};
  inline const int getnbPostProbe(){return nbPostProbe;};
  inline MyVector<PostProbe> & getPostProbeList() {return postProbeList;};
  
  void execute(double time);
  void setMesh(Mesh * _pMesh){ pMesh = _pMesh;};
  void setMesh(const Mesh * _pMesh){ pMesh = _pMesh;};
  void finish(double time);
  
private:
  const Mesh * pMesh;
  int nbPostProbe; //!< Number of post-processing probes
  MyVector<PostProbe> postProbeList;
  int nbPostGlobal; //!< Number of post-processing on whole domain
  MyVector<PostGlobal> postGlobalList;
};

#endif
