// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef TIMESCHEME_H
#define TIMESCHEME_H

#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <iostream>

using namespace std;

class Equation;
class Simulation;

class TimeScheme {
public:
  TimeScheme();
  virtual ~TimeScheme(){};

  void read(ifstream& inputFile);

  void associateSimulation(Simulation * _pSimulation){ pSimulation = _pSimulation;};

  void makeTimeStep();
  virtual void makeTimeStepOnEquation(const Equation* pEqn)=0;

protected:
  const Simulation* pSimulation;
  double timeBegin;
  double timeEnd;
  double time;
  double timeStep;
  double nbOfTimeStep;
  
};

#endif
