// Copyright (C) 2004 by flowerteam (openflower@netcourrier.com)
// Licensed under the GNU GPL Version 2.

#ifndef MYMATRIX_H
#define MYMATRIX_H

#include <MyVector.h>
#include <vector>

using namespace std;

template <class T >
class MyMatrix : public vector< MyVector<T> >
{
public:
  MyMatrix<T>() {};
  ~MyMatrix<T>() {};
  void add(const MyMatrix<T>& );
  void multiply(const double );
  void resizes(const int , const int );
  double min(int );
  double max(int );
};


////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
template <class T>
void MyMatrix<T>::add(const MyMatrix<T> & MM2)
{
  assert((*this).size()==MM2.size());
  assert((*this)[0].size()==MM2[0].size());
  for (int i=0;i<MM2.size();i++)
    for  (int j=0;j<MM2.size();j++)
      (*this)[i][j]=(*this)[i][j]+MM2[i][j]; 
};

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
template <class T>
void MyMatrix<T>::multiply(const double n)
{
  for (int i=0;i<(*this).size();i++)
    for  (int j=0;j<(*this)[0].size();j++)
      (*this)[i][j]=(*this)[i][j]*n;
};

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
template <class T>
void MyMatrix<T>::resizes(int  n1,int  n2)
{
  (*this).resize(n1);
  for(int i=0;i<n1;i++)
    (*this)[i].resize(n2);
};

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
template <class T>
double MyMatrix<T>::min(int  n)
{  
  double min=1.e30;
  for (unsigned int i=0;i<(*this).size();i++)
      if((*this)[i][n]<min) min=(*this)[i][n];
  return min;
};

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
template <class T>
double MyMatrix<T>::max(int  n)
{  
  double max=-1.e30;
  for (unsigned int i=0;i<(*this).size();i++)
      if((*this)[i][n]>max) max=(*this)[i][n];
  return max;
};


#endif
