// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifndef MYVECTOR_H
#define MYVECTOR_H

#include <vector>
#include <string>
#include <algorithm>
#include <assert.h>

using namespace std;

template <class T >
class MyVector : public vector<T>
{
public:
  MyVector<T>() {};
  ~MyVector<T>() {};
  void add(const MyVector<T>& );
  void multiply(const double );
  int search(const T& );
/*  template <class C>
  int search(const C& v,T val); */
/*  int search(const string& );  // searches a string in a vector and returns the number of the vector element if any,
                               // and -1 if it was not found.
  int search(const int );      // same with integer
*/
};



////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
template <class T>
void MyVector<T>::add(const MyVector<T> & MV2)
{
  assert((*this).size()==MV2.size());
  for (unsigned int i=0;i<MV2.size();i++)
    {
    (*this)[i]=(*this)[i]+MV2[i]; 
    }
};



////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
template <class T>
void MyVector<T>::multiply(const double n)
{
  for (unsigned int i=0;i<(*this).size();i++)
    {
    (*this)[i]=(*this)[i]*n;
    }
};


 

/*!\brief Searches for an element in a MyVector.
 * Searches a pattern in a MyVector and returns the number of the
 * element if any, and -1 if it was not found.
 * \param val A variable of template type to search for in the MyVector iterator.
*/
template <class T>
int MyVector<T>::search(const T& val)
  {
  typename MyVector<T>::const_iterator i = find((*this).begin(),(*this).end(),val);
  int index = i - (*this).begin();
  if(i==(*this).end()) index=-1;
  return index;
};



#endif
