// Copyright (C) 2004 by OpenFlower Team
// http://sourceforge.net/projects/openflower/
// Licensed under the GNU GPL Version 2.

#ifdef HAVE_CONFIG_H
#include <config.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#endif

#include <Simulation.h>

using namespace std;

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
void usage()
{
  cerr << "Expecting one argument: the simulation definition file!" << endl;
  cerr << "Usage is : openflower file.flw" <<endl;
  exit(-1);
}

////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////
int main(int argc, char *argv[])
{

  cout << "########################################################" << endl;
  cout << "#                OpenFlower  V0.3                      #" << endl;
  cout << "#  Free Open Source CFD Software                       #" << endl;
  cout << "#  Copyright (C) 2004 by OpenFlower Team               #" << endl;
  cout << "#  http://sourceforge.net/projects/openflower/         #" << endl;
  cout << "#  Licensed under the GNU GPL Version 2.               #" << endl;
  cout << "########################################################" << endl;

  Simulation simulation;

  switch(argc)
    {
    case 1 :
           {
           cout << " Simulation data file: ";
           string s0;
           cin >> s0;
           simulation.setFile(s0);
           break;
           }
    case 2 :
           {
           simulation.setFile(argv[1]);
           break;
           }
    default :
            {
            usage();
            break;
	    }
    }

  simulation.read();

  simulation.prepare();

  simulation.solve();

  return EXIT_SUCCESS;
}

